<template>
    <div>
        <v-row no-gutters justify="center">
            <v-col cols="2">
                <div class="d-flex align-center pa-2" style="width: 100%;">
                    <input class="presentation-title" v-model="title"/>
                </div>
                <MinSlidesPreview :id="id" class="mr-3"/>
            </v-col>
            <v-col cols="10">
                <div class="ma-3">
                    <froala :tag="'textarea'" :config="config" v-model="content"></froala>
                </div>
            </v-col>
        </v-row>
    </div>
</template>

<script>
import MinSlidesPreview from "@/components/MinSlidesPreview.vue";
import {
    getContentOfSlide,
    getPresentations
} from "@/services/presentations";

export default {
    data() {
        return {
            config: {
                events: {
                    "froalaEditor.initialized": function () {
                        console.log("initialized");
                    },
                },
                heightMin: 600,
            },
            presentationTitle: ''
        };
    },
    props: ["id", "slideId"],
    components: {
        MinSlidesPreview,
    },
    methods: {
        getContentOfSlide,
        getPresentations,
        saveTitle(title) {
            try {
                this.$store.dispatch('slide/updatePresentation', {
                    userId: this.$store.getters['user/user'].uid,
                    presentationId: this.id,
                    title
                });
            } catch (e) {
                console.error(e);
            }
        }
    },
    computed: {
        title: {
            get() {
                return this.$store.state.slide.presentations[this.id].title;
            },
            set(value) {
                this.saveTitle(value);
            }
        },
        content: {
            get() {
                return getContentOfSlide(this.id, this.slideId);
            },
            set(value) {
                try {
                    const payload = {
                        presentationId: this.id,
                        slideId: this.slideId,
                        value
                    }
                    this.$store.dispatch('slide/updateSlide', payload)
                } catch (e) {
                    console.error(e);
                }
            },
        },
    },
};
</script>
